package com.ynet.life.sujrb.action;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.imageio.plugins.bmp.BMPImageReader;
import com.sun.imageio.plugins.gif.GIFImageReader;
import com.sun.imageio.plugins.jpeg.JPEGImageReader;
import com.sun.imageio.plugins.png.PNGImageReader;
import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.web.multipart.implement.GENEMultipartFile;
import com.ynet.life.action.LifeJDBCAction;
import com.ynet.life.base.LifeDBAccess;
import com.ynet.life.base.LifeStandard;
import com.ynet.life.base.Trace;
import com.ynet.life.sujrb.img.AnimatedGifEncoder;
import com.ynet.life.sujrb.img.GifDecoder;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.awt.image.ImageObserver;
import java.awt.image.WritableRaster;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Iterator;
import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.MemoryCacheImageInputStream;

/* loaded from: com_ynet_life_sujrb_action.jar:com/ynet/life/sujrb/action/IconUploadAction.class */
public class IconUploadAction extends LifeJDBCAction {
    private String INSERT_SQL = "insert into PB_CST_ICON(CIP_CSTNO,CIP_UPDATE,CIP_ICON) values(?,?,?)";
    private String SELECT_SQL = "select count(*) from PB_CST_ICON where CIP_CSTNO = ?";
    private String UPDATE_SQL = "update PB_CST_ICON set CIP_ICON = ?, CIP_UPDATE = ? where CIP_CSTNO = ?";

    public String execute(Context context) throws GENEException {
        Connection conn = null;
        int num = 0;
        try {
            try {
                try {
                    try {
                        String filePathName = ((GENEMultipartFile) context.getDataValue("uploadFile")).getTempFileName();
                        InputStream inputStream1 = new FileInputStream(filePathName);
                        String date = LifeStandard.getServerTime("yyyyMMdd");
                        String time = LifeStandard.getServerTime("HHmmss");
                        String customerId = (String) context.getDataValue("customerId");
                        File fileImg = new File("d:/file/");
                        if (!fileImg.exists()) {
                            fileImg.mkdir();
                        }
                        String fileType = getImageType(filePathName);
                        String urlPath = String.valueOf("d:/file/") + customerId + "." + fileType;
                        OutputStream outputStream1 = new BufferedOutputStream(new FileOutputStream(urlPath));
                        if ("gif".equals(fileType)) {
                            GifDecoder decoder = new GifDecoder();
                            decoder.read(inputStream1);
                            AnimatedGifEncoder e = new AnimatedGifEncoder();
                            e.start(outputStream1);
                            e.setRepeat(decoder.getLoopCount());
                            e.setTransparent(Color.BLACK);
                            int n = decoder.getFrameCount();
                            for (int i = 0; i < n; i++) {
                                BufferedImage targetFrame = resize(decoder.getFrame(i), 65, 69);
                                e.setDelay(decoder.getDelay(i));
                                e.addFrame(targetFrame);
                            }
                            e.finish();
                        } else if ("png".equals(fileType)) {
                            ImageIO.write(resize(ImageIO.read(inputStream1), 65, 69), "png", outputStream1);
                        } else {
                            BufferedImage image = ImageIO.read(inputStream1);
                            BufferedImage tag = new BufferedImage(65, 69, 1);
                            tag.getGraphics().drawImage(image.getScaledInstance(65, 69, 4), 0, 0, (ImageObserver) null);
                            JPEGCodec.createJPEGEncoder(outputStream1).encode(tag);
                        }
                        outputStream1.flush();
                        outputStream1.close();
                        inputStream1.close();
                        File downloadFile = new File(urlPath);
                        InputStream inputStream = new FileInputStream(downloadFile);
                        Connection connection = LifeDBAccess.getConnection(getDataSource());
                        conn = connection;
                        PreparedStatement psInsert = connection.prepareStatement(this.INSERT_SQL);
                        PreparedStatement psSelect = conn.prepareStatement(this.SELECT_SQL);
                        PreparedStatement psUpdate = conn.prepareStatement(this.UPDATE_SQL);
                        psSelect.setString(1, customerId);
                        Trace.logInfo("LifeAction", "执行查询语句-->" + this.SELECT_SQL);
                        ResultSet rs = psSelect.executeQuery();
                        while (rs.next()) {
                            num = rs.getInt(1);
                        }
                        Trace.logInfo("LifeAction", "执行查询结果-->".concat(String.valueOf(num)));
                        if (num > 0) {
                            psUpdate.setBinaryStream(1, inputStream, (int) downloadFile.length());
                            psUpdate.setString(2, String.valueOf(date) + time);
                            psUpdate.setString(3, customerId);
                            Trace.logInfo("LifeAction", "执行更新语句-->" + this.UPDATE_SQL);
                            psUpdate.executeUpdate();
                        } else {
                            psInsert.setString(1, customerId);
                            psInsert.setString(2, String.valueOf(date) + time);
                            psInsert.setBinaryStream(3, inputStream, (int) downloadFile.length());
                            Trace.logInfo("LifeAction", "执行插入语句-->" + this.INSERT_SQL);
                            psInsert.executeUpdate();
                        }
                        conn.commit();
                        try {
                            inputStream.close();
                        } catch (IOException unused) {
                        }
                        LifeDBAccess.releaseConnection(conn);
                        return "0";
                    } catch (FileNotFoundException e2) {
                        Trace.logError("LifeAction", "数据库上传文件异常FILE", e2);
                        LifeDBAccess.releaseConnection(conn);
                        return "0";
                    }
                } catch (SQLException e3) {
                    Trace.logError("LifeAction", "数据库上传文件异常SQL", e3);
                    LifeDBAccess.releaseConnection(conn);
                    return "0";
                }
            } catch (IOException e4) {
                Trace.logError("LifeAction", "数据库上传文件异常FILE", e4);
                LifeDBAccess.releaseConnection(conn);
                return "0";
            } catch (GENEException e5) {
                Trace.logError("LifeAction", "数据库上传文件异常GENE", e5);
                throw e5;
            }
        } catch (Throwable th) {
            LifeDBAccess.releaseConnection(conn);
            throw th;
        }
    }

    private static BufferedImage resize(BufferedImage source, int targetW, int targetH) {
        BufferedImage target;
        int type = source.getType();
        double sx = targetW / source.getWidth();
        double sy = targetH / source.getHeight();
        if (sx < sy) {
            targetW = (int) (sx * source.getWidth());
        } else {
            targetH = (int) (sy * source.getHeight());
        }
        if (type == 0) {
            ColorModel cm = source.getColorModel();
            WritableRaster raster = cm.createCompatibleWritableRaster(targetW, targetH);
            boolean alphaPremultiplied = cm.isAlphaPremultiplied();
            target = new BufferedImage(cm, raster, alphaPremultiplied, (Hashtable) null);
        } else {
            target = new BufferedImage(targetW, targetH, type);
        }
        Graphics2D g = target.createGraphics();
        g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_NEAREST_NEIGHBOR);
        g.drawRenderedImage(source, AffineTransform.getScaleInstance(sx, sy));
        g.dispose();
        return target;
    }

    public static String getImageType(String path) throws IOException {
        FileInputStream fis = new FileInputStream(path);
        int leng = fis.available();
        BufferedInputStream buff = new BufferedInputStream(fis);
        byte[] mapObj = new byte[leng];
        buff.read(mapObj, 0, leng);
        String type = "";
        ByteArrayInputStream bais = null;
        MemoryCacheImageInputStream mcis = null;
        try {
            bais = new ByteArrayInputStream(mapObj);
            MemoryCacheImageInputStream memoryCacheImageInputStream = new MemoryCacheImageInputStream(bais);
            mcis = memoryCacheImageInputStream;
            Iterator itr = ImageIO.getImageReaders(memoryCacheImageInputStream);
            while (itr.hasNext()) {
                ImageReader reader = (ImageReader) itr.next();
                if (reader instanceof GIFImageReader) {
                    type = "gif";
                } else if (reader instanceof JPEGImageReader) {
                    type = "jpg";
                } else if (reader instanceof PNGImageReader) {
                    type = "png";
                } else if (reader instanceof BMPImageReader) {
                    type = "bmp";
                }
            }
            try {
                bais.close();
            } catch (IOException unused) {
            }
            try {
                mcis.close();
            } catch (IOException unused2) {
            }
            return type;
        } catch (Throwable th) {
            if (bais != null) {
                try {
                    bais.close();
                } catch (IOException unused3) {
                }
            }
            if (mcis != null) {
                try {
                    mcis.close();
                } catch (IOException unused4) {
                }
            }
            throw th;
        }
    }
}
